/*******************************************************************************
 * FoxBillboardUIObjectBase generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxBillboardUIObjectBase extends GFxObject within GFxMoviePlayer
    abstract
    native(HUD)
    config(HUD);

struct native BillboardIconInfo
{
    var float Distance;
    var float Scale;
    var float Opacity;

    structdefaultproperties
    {
        Distance=0.0
        Scale=0.0
        Opacity=0.0
    }
};

struct native BillboardAddObjectiveWidget
{
    var float X;
    var float Y;
    var float DelayTime;
    var float TransitionTime;

    structdefaultproperties
    {
        X=0.0
        Y=0.0
        DelayTime=0.0
        TransitionTime=0.0
    }
};

var protected const config BillboardIconInfo NearestBillboardInfo;
var protected const config BillboardIconInfo FurthestBillboardInfo;
var protected const config BillboardIconInfo DockedBillboardInfo;
var const string symbolname;
var transient string instancename;
var const name TacticalSpecificClassName;
var transient FoxPC PCOwner;
var protected const float LastOpacityVal;
var protected const float LastScaleVal;
var private const float LastInterpVal;
var private const Vector2D LastScreenPos;
var protected const bool bWasVisible;
var protected const bool bAlwaysShowInHRV;
var protected bool bShowOnlyInHRV;
var protected const bool bDockable;
var protected bool bIsDocked;
var protected bool bWantsTeamColor;
var protected bool bSupportsNoTeamColor;
var protected bool bSetColorEachFrame;
var protected const bool bKeepOnScreen;
var protected transient bool bLastDistanceTextDrawn;
var protected const bool bDrawDistance;
var const config bool bHideIfOutOfRange;
var protected const bool bSupportsOpacityChangeInTightAim;
var protected const bool bOnSameTeam;
var protected const config string BlueTeamColor;
var protected const config string RedTeamColor;
var protected const config string NoTeamColor;
var protected transient string TeamColor;
var protected const config Vector2D DockLoc;
var protected const config float BillboardWidth;
var protected const config float BillboardHeight;
var protected const config float DockTime;
var protected transient int LastDistance;
var const localized string LocStringMeters;
var const config Vector WorldLocationOffset;
var const config float TightAimOpacityMultiplier;
var() const config BillboardAddObjectiveWidget AddObjectiveWidget;

function Initialize()
{
    //return;    
}

// Export UFoxBillboardUIObjectBase::execSetVisible(FFrame&, void* const)
native function SetVisible(bool bVisible);

function NotifyTeamChange()
{
    bWantsTeamColor = default.bWantsTeamColor;
    TeamColor = "";
    //return;    
}

event as_SetTeamColor(string NewTeamColor)
{
    TeamColor = NewTeamColor;
    SetString("billboardColor", NewTeamColor);
    //return;    
}

event string GetNoTeamColor()
{
    return NoTeamColor;
    //return ReturnValue;    
}

event string GetRedTeamColor()
{
    return RedTeamColor;
    //return ReturnValue;    
}

event string GetBlueTeamColor()
{
    return BlueTeamColor;
    //return ReturnValue;    
}

event TeamIsSet(int TeamIndex)
{
    //return;    
}

// Export UFoxBillboardUIObjectBase::execShouldOverrideReplicatedName(FFrame&, void* const)
native function bool ShouldOverrideReplicatedName(FoxPawn PawnToCheck, out string OverrideName);

event DockBillboard()
{
    as_TweenBillboard(int(DockLoc.X), int(DockLoc.Y), DockTime);
    //return;    
}

function as_TweenBillboard(int XPos, int YPos, float DurationSeconds)
{
    ActionScriptVoid("tweenBillboard");
    //return;    
}

event as_SetLabel(string NewLabel)
{
    SetString("billboardLabel", NewLabel);
    //return;    
}

event UndockBillboard()
{
    //return;    
}

defaultproperties
{
    NearestBillboardInfo=(Distance=500.0,Scale=100.0,Opacity=100.0)
    FurthestBillboardInfo=(Distance=4000.0,Scale=60.0,Opacity=80.0)
    LastInterpVal=-1.0
    bWasVisible=true
    BlueTeamColor="0x00D5FF"
    RedTeamColor="0xFF6A00"
    NoTeamColor="0xCCCCCC"
    DockLoc=(X=0.0,Y=255.0)
    DockTime=0.50
    LocStringMeters="m"
    TightAimOpacityMultiplier=0.40
    AddObjectiveWidget=(X=0.0,Y=-100.0,DelayTime=0.80,TransitionTime=0.50)
}